---
title: '<tbody>: The Table Body element'
slug: Web/HTML/Element/tbody
tags:
  - Element
  - HTML
  - HTML tabular data
  - Reference
  - Table Body
  - Table Contents
  - Tables
  - Web
  - tbody
---
<div>{{HTMLRef}}</div>

<p><span class="seoSummary">The <strong>HTML Table Body element</strong> (<strong><code>&lt;tbody&gt;</code></strong>) encapsulates a set of table rows ({{HTMLElement("tr")}} elements), indicating that they comprise the body of the table ({{HTMLELement("table")}}).</span></p>

<div>{{EmbedInteractiveExample("pages/tabbed/tbody.html","tabbed-taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples </a> and send us a pull request.</div>

<p>The <code>&lt;tbody&gt;</code> element, along with its cousins {{HTMLElement("thead")}} and {{HTMLElement("tfoot")}}, provide useful semantic information that can be used when rendering for either screen or printer as well as for {{Glossary("accessibility")}} purposes.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row"><a href="/en-US/docs/Web/Guide/HTML/Content_categories">Content categories</a></th>
   <td>None.</td>
  </tr>
  <tr>
   <th scope="row">Permitted content</th>
   <td>Zero or more {{ HTMLElement("tr") }} elements.</td>
  </tr>
  <tr>
   <th scope="row">Tag omission</th>
   <td>The <code>&lt;tbody&gt;</code> element is not a required child element for a parent {{ HTMLElement("table") }} element to graphically render. However, it must not be present, if its parent {{ HTMLElement("table") }} element has a {{ HTMLElement("tr") }} element as a child.</td>
  </tr>
  <tr>
   <th scope="row">Permitted parents</th>
   <td>Within the required parent {{ HTMLElement("table") }} element, the <code>&lt;tbody&gt;</code> element can be added after a {{ HTMLElement("caption") }}, {{HTMLElement("colgroup") }}, and a {{ HTMLElement("thead") }} element.</td>
  </tr>
  <tr>
   <th scope="row">Implicit ARIA role</th>
   <td><code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Rowgroup_Role">rowgroup</a></code></td>
  </tr>
  <tr>
   <th scope="row">Permitted ARIA roles</th>
   <td>Any</td>
  </tr>
  <tr>
   <th scope="row">DOM interface</th>
   <td>{{domxref("HTMLTableSectionElement")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Attributes">Attributes</h2>

<p>This element includes the <a href="/en-US/docs/Web/HTML/Global_attributes">global attributes</a>.</p>

<h3 id="Deprecated_attributes">Deprecated attributes</h3>

<dl>
 <dt>{{ htmlattrdef("align") }} {{deprecated_inline}}</dt>
 <dd>This enumerated attribute specifies how horizontal alignment of each cell content will be handled. Possible values are:
 <ul>
  <li><code>left</code>, aligning the content to the left of the cell</li>
  <li><code>center</code>, centering the content in the cell</li>
  <li><code>right</code>, aligning the content to the right of the cell</li>
  <li><code>justify</code>, inserting spaces into the textual content so that the content is justified in the cell</li>
  <li><code>char</code>, aligning the textual content on a special character with a minimal offset, defined by the {{ htmlattrxref("char", "tbody") }} and {{ htmlattrxref("charoff", "tbody") }} attributes.</li>
 </ul>

 <p>If this attribute is not set, the <code>left</code> value is assumed.</p>

 <p>As this attribute is deprecated, use the CSS {{cssxref("text-align")}} property instead.</p>

 <div class="note"><strong>Note: </strong>The equivalent <code>text-align</code> property for the <code>align="char"</code> is not implemented in any browsers yet. See the <a href="/en-US/docs/Web/CSS/text-align#Browser_compatibility"><code>text-align</code>'s browser compatibility section</a> for the <code>&lt;string&gt;</code> value.</div>
 </dd>
 <dt>{{htmlattrdef("bgcolor")}} {{Deprecated_inline}}</dt>
 <dd>
 <p>The background color of the table. It is a <a href="/en-US/docs/Web/CSS/color_value#RGB_colors">6-digit hexadecimal RGB code</a>, prefixed by a '<code>#</code>'. One of the predefined <a href="/en-US/docs/Web/CSS/color_value#Color_keywords">color kewords</a> can also be used.</p>

 <p>As this attribute is deprecated, use the CSS {{cssxref("background-color")}} property instead.</p>
 </dd>
 <dt>{{ htmlattrdef("char") }} {{deprecated_inline}}</dt>
 <dd>
 <p>This attribute is used to set the character to align the cells in a column on. Typical values for this include a period (<code>.</code>) when attempting to align numbers or monetary values. If {{htmlattrxref("align", "tbody")}} is not set to <code>char</code>, this attribute is ignored.</p>
 </dd>
 <dt>{{ htmlattrdef("charoff") }} {{deprecated_inline}}</dt>
 <dd>This attribute is used to indicate the number of characters to offset the column data from the alignment characters specified by the <code>char</code> attribute.</dd>
 <dt>{{ htmlattrdef("valign") }} {{deprecated_inline}}</dt>
 <dd>This attribute specifies the vertical alignment of the text within each row of cells of the table header. Possible values for this attribute are:
 <ul>
  <li><code>baseline</code>, which will put the text as close to the bottom of the cell as it is possible, but align it on the <a class="external" href="https://en.wikipedia.org/wiki/Baseline_%28typography%29">baseline</a> of the characters instead of the bottom of them. If characters are all of the size, this has the same effect as <code>bottom</code>.</li>
  <li><code>bottom</code>, which will put the text as close to the bottom of the cell as it is possible;</li>
  <li><code>middle</code>, which will center the text in the cell;</li>
  <li>and <code>top</code>, which will put the text as close to the top of the cell as it is possible.</li>
 </ul>

 <p>As this attribute is deprecated, use the CSS {{cssxref("vertical-align")}} property instead.</p>
 </dd>
</dl>

<h2 id="Usage_notes">Usage notes</h2>

<ul>
 <li>If the table includes a {{HTMLElement("thead")}} block (to semantically identify header rows), the <code>&lt;tbody&gt;</code> block <em>must</em> come after it.</li>
 <li>If you use <code>&lt;tbody&gt;</code>, you can't also have table rows ({{HTMLElement("tr")}} elements) which are direct children of the {{HTMLElement("table")}} but not included inside the <code>&lt;tbody&gt;</code>. All non-header and non-footer rows must be inside the <code>&lt;tbody&gt;</code> if one is used.</li>
 <li>When printing a document, the <code>&lt;thead&gt;</code> and {{htmlelement("tfoot")}} elements specify information that may be the same—or at least very similar—on every page of a multi-page table, while the <code>&lt;tbody&gt;</code> element's contents generally will differ from page to page.</li>
 <li>When a table is presented in a screen context (such as a window) which is not large enough to display the entire table, the {{Glossary("user agent")}} may let the user scroll the contents of the <code>&lt;thead&gt;</code>, <code>&lt;tbody&gt;</code>, <code>&lt;tfoot&gt;</code>, and {{HTMLElement("caption")}} blocks separately from one another for the same parent table.</li>
 <li>You <em>may</em> use more than one <code>&lt;tbody&gt;</code> per table as long as they are all consecutive. This lets you divide the rows in large tables into sections, each of which may be separately formatted if so desired.</li>
</ul>

<h2 id="Examples">Examples</h2>

<p>Below are some examples showing the use of the <code>&lt;tbody&gt;</code> element. For more examples of this tag in use, see the examples for {{ HTMLElement("table", "", "#Examples") }}.</p>

<h3 id="Basic_example">Basic example</h3>

<p>In this relatively simple example, we create a table listing information about a group of students with a {{HTMLElement("thead")}} and a {{HTMLElement("tbody")}}, with a number of rows in the body.</p>

<h4 id="HTML">HTML</h4>

<p>The table's HTML is shown here. Note that all of the body cells including information about students are contained within a single <code>&lt;tbody&gt;</code> element.</p>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th&gt;Student ID&lt;/th&gt;
      &lt;th&gt;Name&lt;/th&gt;
      &lt;th&gt;Major&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;td&gt;3741255&lt;/td&gt;
      &lt;td&gt;Jones, Martha&lt;/td&gt;
      &lt;td&gt;Computer Science&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;3971244&lt;/td&gt;
      &lt;td&gt;Nim, Victor&lt;/td&gt;
      &lt;td&gt;Russian Literature&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;4100332&lt;/td&gt;
      &lt;td&gt;Petrov, Alexandra&lt;/td&gt;
      &lt;td&gt;Astrophysics&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;</pre>

<h4 id="CSS">CSS</h4>

<p>The CSS to style our table is shown next.</p>

<pre class="brush: css notranslate">table {
  border: 2px solid #555;
  border-collapse: collapse;
  font: 16px "Lucida Grande", "Helvetica", "Arial", sans-serif;
}</pre>

<p>First, the table's overall style attributes are set, configuring the thickness, style, and color of the table's exterior borders and using {{cssxref("border-collapse")}} to ensure that the border lines are shared among adjacent cells rather than each having its own borders with space in between. {{cssxref("font")}} is used to establish an initial font for the table.</p>

<pre class="brush: css notranslate">th, td {
  border: 1px solid #bbb;
  padding: 2px 8px 0;
  text-align: left;
}</pre>

<p>Then the style is set for the majority of the cells in the table, including all data cells but also those styles shared between our {{HTMLElement("td")}} and {{HTMLElement("th")}} cells. The cells are given a light gray outline which is a single pixel thick, padding is adjusted, and all cells are left-aligned using {{cssxref("text-align")}}</p>

<pre class="brush: css notranslate">thead &gt; tr &gt; th {
  background-color: #cce;
  font-size: 18px;
  border-bottom: 2px solid #999;
}</pre>

<p>Finally, header cells contained within the {{HTMLElement("thead")}} block are given additional styling. They use a darker {{cssxref("background-color")}}, a larger font size, and a thicker, darker bottom border than the other cell borders.</p>

<h4 id="Result">Result</h4>

<p>The resulting table looks like this:</p>

<p>{{EmbedLiveSample("Basic_example", 650, 150)}}</p>

<h3 id="Multiple_bodies">Multiple bodies</h3>

<p>You can create multiple sections within a table by using multiple <code>&lt;tbody&gt;</code> elements. Each may potentially have its own header row or rows; however, <em>there can be only one {{HTMLElement("thead")}} per table!</em> Because of that, you need to use a {{HTMLElement("tr")}} filled with {{HTMLElement("th")}} elements to create headers within each <code>&lt;tbody&gt;</code>. Let's see how that's done.</p>

<p>Let's take the previous example, add some more students to the list, and update the table so that instead of listing each student's major on every row, the students are grouped by major, with heading rows for each major.</p>

<h4 id="Result_2">Result</h4>

<p>First, the resulting table, so you know what we're building:</p>

<p>{{EmbedLiveSample("Multiple_bodies", 650, 250)}}</p>

<h4 id="HTML_2">HTML</h4>

<p>The revised HTML looks like this:</p>

<pre class="brush: html notranslate">&lt;table&gt;
  &lt;thead&gt;
    &lt;tr&gt;
      &lt;th&gt;Student ID&lt;/th&gt;
      &lt;th&gt;Name&lt;/th&gt;
    &lt;/tr&gt;
  &lt;/thead&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;th colspan="2"&gt;Computer Science&lt;/th&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;3741255&lt;/td&gt;
      &lt;td&gt;Jones, Martha&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;4077830&lt;/td&gt;
      &lt;td&gt;Pierce, Benjamin&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;5151701&lt;/td&gt;
      &lt;td&gt;Kirk, James&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;th colspan="2"&gt;Russian Literature&lt;/th&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;3971244&lt;/td&gt;
      &lt;td&gt;Nim, Victor&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
  &lt;tbody&gt;
    &lt;tr&gt;
      &lt;th colspan="2"&gt;Astrophysics&lt;/th&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;4100332&lt;/td&gt;
      &lt;td&gt;Petrov, Alexandra&lt;/td&gt;
    &lt;/tr&gt;
    &lt;tr&gt;
      &lt;td&gt;8892377&lt;/td&gt;
      &lt;td&gt;Toyota, Hiroko&lt;/td&gt;
    &lt;/tr&gt;
  &lt;/tbody&gt;
&lt;/table&gt;</pre>

<p>Notice that each major is placed in a separate <code>&lt;tbody&gt;</code> block, the first row of which contains a single {{HTMLElement("th")}} element with a {{htmlattrxref("colspan", "th")}} attribute that spans the entire width of the table. That heading lists the name of the major contained within the <code>&lt;tbody&gt;</code>.</p>

<p>Then each remaining row in each major's <code>&lt;tbody&gt;</code> consists of two cells: the first for the student's ID and the second for their name.</p>

<h4 id="CSS_2">CSS</h4>

<div class="hidden">
<pre class="brush: css notranslate">table {
  border: 2px solid #555;
  border-collapse: collapse;
  font: 16px "Lucida Grande", "Helvetica", "Arial", sans-serif;
}

th, td {
  border: 1px solid #bbb;
  padding: 2px 8px 0;
  text-align: left;
}

thead &gt; tr &gt; th {
  background-color: #cce;
  font-size: 18px;
  border-bottom: 2px solid #999;
}</pre>
</div>

<p>Most of the CSS is unchanged. We do, however, add a slightly more subtle style for header cells contained directly within a <code>&lt;tbody&gt;</code> (as opposed to those which reside in a {{HTMLElement("thead")}}). This is used for the headers indicating each table section's corresponding major.</p>

<pre class="brush: css notranslate">tbody &gt; tr &gt; th {
  background-color: #dde;
  border-bottom: 1.5px solid #bbb;
  font-weight: normal;
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG','tables.html#the-tbody-element','tbody element')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5 W3C','tabular-data.html#the-tbody-element','tbody element')}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("html.elements.tbody")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>CSS properties and <a href="/en-US/docs/Web/CSS/Pseudo-classes">pseudo-classes</a> that may be specially useful to style the <code>&lt;tbody&gt;</code> element:

  <ul>
   <li>the {{ cssxref(":nth-child") }} pseudo-class to set the alignment on the cells of the column;</li>
   <li>the {{ cssxref("text-align") }} property to align all cells content on the same character, like '.'.</li>
  </ul>
 </li>
</ul>
